// (c) Copyright 2013 Cloudera, Inc. All rights reserved.

define(["cloudera/cmf/parcel/ParcelUsage","cloudera/common/UrlParams","underscore"],function(e,t,n){describe("Parcel Usage Test",function(){var r,i=[{id:"1",name:"Cluster 1 - CDH4",fetchUrl:"/cmf/parcel/usage?clusterId=1"},{id:"2",name:"Cluster 2 - CDH4",fetchUrl:"/cmf/parcel/usage?clusterId=2"}],s={headerContainer:"#parcelUsageHeader",container:"#parcelUsageContent",hostPopoverContainer:"#hostPopover",clusters:i},o={message:"OK",data:{racks:[{name:"/rack1",hosts:[{hostId:"1",name:"host1",roles:[]},{hostId:"2",name:"host2",roles:[{name:"Test Role Name 1",roleId:1234,serviceId:56,processes:[{name:"process1",parcels:[{product:"CDH",version:"cdh-v1"},{product:"SOLR",version:"solr-v1"},{product:"IMPALA",version:"impala-v1"}]},{name:"process2",parcels:[{product:"CDH",version:"cdh-v1"},{product:"SOLR",version:"solr-v2"},{product:"IMPALA",version:"impala-v1"}]}]}]},{hostId:"3",name:"host3",roles:[{name:"Test Role Name 3",roleId:4566,serviceId:67,processes:[{name:"process1",parcels:[{product:"CDH",version:"cdh-v1"},{product:"IMPALA",version:"impala-v1"}]},{name:"process2",parcels:[{product:"CDH",version:"cdh-v1"},{product:"SOLR",version:"solr-v2"},{product:"IMPALA",version:"impala-v1"}]}]}]}]}],parcels:[{pv:{product:"CDH",version:"cdh-v1"},processCount:187,activated:!0},{pv:{product:"SOLR",version:"solr-v1"},processCount:141,activated:!1},{pv:{product:"IMPALA",version:"impala-v1"},processCount:187,activated:!0},{pv:{product:"SOLR",version:"solr-v2"},processCount:46,activated:!0}]}};beforeEach(function(){jasmine.Ajax.useMock(),clearAjaxRequests(),$('<div id="parcelUsageHeader">').appendTo("body"),$('<div id="parcelUsageContent">').appendTo("body"),$('<div id="hostPopover">').appendTo("body"),t.remove(["clusterId","productName","versions"])}),afterEach(function(){r.stop(),$("#parcelUsageHeader").remove(),$("#parcelUsageContent").remove(),$("#hostPopover").remove()}),it("should download parcel usage data for cluster 1",function(){r=new e(s);var t=mostRecentAjaxRequest();t.response({status:200,responseText:JSON.stringify(o)}),expect(r.filters.clusterId()).toEqual("1"),expect(r.filters.productName()).toEqual("CDH"),expect(r.filters.versions()).toEqual(["cdh-v1"]);var n=r.clusterModel;expect(n.products().length).toEqual(4),expect(n.products()[0].name).toEqual("CDH"),expect(n.products()[2].versions.length).toEqual(2),expect(n.products()[2].versions[0].version).toEqual("solr-v1"),expect(n.products()[2].versions[1].version).toEqual("solr-v2"),expect(n.hasProduct("CDH")).toEqual(!0),expect(n.hasProduct("UNKNOWN")).toEqual(!1),expect(n.firstProduct().name).toEqual("CDH")}),it("should download parcel usage data and process rack information",function(){r=new e(s);var t=mostRecentAjaxRequest();t.response({status:200,responseText:JSON.stringify(o)}),expect(r.clusterModel.racks().length).toEqual(1),expect(r.clusterModel.racks()[0].hosts.length).toEqual(3);var n=r.clusterModel.racks()[0].hosts[1];expect(n.hostId).toEqual("2"),expect(n.name).toEqual("host2"),expect(n.products()).toEqual(["CDH","IMPALA","SOLR"]),expect(n.versionsForProduct("SOLR")).toEqual(["solr-v1","solr-v2"]);var i=n.rolesForProductVersion("SOLR","solr-v1");expect(i.length).toEqual(1),expect(i[0].roleId).toEqual(1234),expect(i[0].serviceId).toEqual(56),expect(i[0].instanceStatusUrl).toEqual("/cmf/services/56/instances/1234/status")}),it("Should update hosts when filters are changed",function(){r=new e(s);var t=mostRecentAjaxRequest();t.response({status:200,responseText:JSON.stringify(o)}),r.filters.clusterId(i[1].id),r.clusterChanged(),t=mostRecentAjaxRequest();var u=n.clone(o);u.data.racks[0].name="/Cluster2-Rack1",u.data.racks[0].hosts[0].name="Cluster2-Host1",u.data.racks[0].hosts[1].name="Cluster2-Host2",t.response({status:200,responseText:JSON.stringify(u)}),expect(r.clusterModel.racks().length).toEqual(1),expect(r.clusterModel.racks()[0].name).toEqual("/Cluster2-Rack1");var a=r.clusterModel.racks()[0].hosts[1];expect(a.name).toEqual("Cluster2-Host2"),expect(a.products()).toEqual(["CDH","IMPALA","SOLR"]),expect(a.styleForProductVersions(r.selectedProduct(),r.filters.versions())).toEqual("host host-style-activated"),expect(a.versionsForProduct("SOLR")).toEqual(["solr-v1","solr-v2"]),r.filters.productName("SOLR"),r.productChanged(),a=r.clusterModel.racks()[0].hosts[1],expect(a.styleForProductVersions(r.selectedProduct(),r.filters.versions())).toEqual("host host-style-multiple"),r.filters.versions(["solr-v1"]),r.versionsChanged(),a=r.clusterModel.racks()[0].hosts[1],expect(a.styleForProductVersions(r.selectedProduct(),r.filters.versions())).toEqual("host host-style-0")}),it("should handle no clusters",function(){var t={headerContainer:"#parcelUsageHeader",container:"#parcelUsageContent",hostPopoverContainer:"#hostPopover",clusters:[]};r=new e(t),expect(r.hasClusters()).toEqual(!1)}),it("should handle bad cluster data",function(){spyOn($,"publish"),r=new e(s);var t=mostRecentAjaxRequest();t.response({status:200,responseText:JSON.stringify({message:"Error message",data:null})}),expect($.publish).wasCalledWith("showError",["Error message"]),expect(r.clusterModel.racks().length).toEqual(0),expect(r.clusterModel.products().length).toEqual(0)}),it("should calculate the correct style for the host",function(){r=new e(s);var t=mostRecentAjaxRequest();t.response({status:200,responseText:JSON.stringify(o)}),r.filters.productName("SOLR"),r.filters.versions(["solr-v1"]);var n=r.clusterModel.racks()[0].hosts[0],i=r.clusterModel.racks()[0].hosts[1],u=r.selectedProduct(),a=r.filters.versions();expect(n.styleForProductVersions(u,a)).toEqual("host host-style-disabled"),expect(i.styleForProductVersions(u,a)).toEqual("host host-style-0"),r.filters.versions(["solr-v1","solr-v2"]),a=r.filters.versions(),expect(i.styleForProductVersions(u,a)).toEqual("host host-style-multiple")}),it("should calculate the correct style when all products is choosen",function(){r=new e(s);var t=mostRecentAjaxRequest();t.response({status:200,responseText:JSON.stringify(o)}),r.filters.productName("__multiple__"),r.filters.versions(["active","older"]);var n=r.clusterModel.racks()[0].hosts[0],i=r.clusterModel.racks()[0].hosts[1],u=r.clusterModel.racks()[0].hosts[2],a=r.selectedProduct(),f=r.filters.versions();expect(n.styleForProductVersions(a,f)).toEqual("host host-style-disabled"),expect(i.styleForProductVersions(a,f)).toEqual("host host-style-running-older"),expect(u.styleForProductVersions(a,f)).toEqual("host host-style-running-active")}),it("should identify when the cluster uses packages",function(){r=new e(s);var t=mostRecentAjaxRequest();t.response({status:200,responseText:JSON.stringify(o)}),expect(r.usesParcels()).toEqual(!0),r.filters.clusterId(i[1].id),r.clusterChanged(),t=mostRecentAjaxRequest();var u=n.clone(o);u.data.parcels=[],t.response({status:200,responseText:JSON.stringify(u)}),expect(r.usesParcels()).toEqual(!1)})})})